% this file declares global variables which are private to the BERGulator files

% Copyright 1997-1998 Phil Schniter

  % miscellaneous parameters
  global N_max 		% max # iterations in currently plotted trajectories
  global SC 		% (finite-element) regressor matrix
  global colr 		% trace color spec
  global f_opt_old 	% previous MMSE optimal equalizer
  global ranges 	% ranges on surface plot
  global ranges_old 	% previous ranges on surface plot
  global origin 	% origin of surface plot
  global N_v		% number of contour lines on surface plot
  global real_noise	% true if noise is real-valued
  global real_source 	% true if source is real-valued
  global sim_ran 	% true if a valid simulation has been run
  global src_type 	% 1-5 for PAM, 6-10 for QAM
  global src_type_old 	% previous source type
  global se_gamma 	% godard radius for SE-CMA
  global wsga_gamma	% godard radius for WSGA
  global dse_gamma 	% godard radius for DSE-CMA
  global ncma_alpha 	% regularization factor for N-CMA
  global dse_alpha_old 	% previous dither amplitude for DSE-CMA
  global SNR_ok 	% true if SNR is above a given threshold
  global D_u		% decimation factor of CMA update 

  % trace handles
  global h_trace_b 	% sign boundaries trace record
  global h_trace_c 	% cost-contour trace record
  global h_trace_f 	% freq-resp trace record
  global h_trace_ff 	% globally MMSE freq-resp trace record
  global h_trace_fff 	% locally MMSE freq-resp trace record
  global h_trace_i 	% impulse-resp trace record
  global h_trace_ii 	% globally MMSE impulse-resp trace record
  global h_trace_iii 	% locally MMSE impulse-resp trace record
  global h_trace_t 	% surface tap-trajectory trace record
  global h_trace_tt	% tap-trajectory trace record
  global h_trace_h	% CMA/MSE-histories trace record
  global h_trace_s	% scatter plot (const. diagram) trace record
  global h_trace_mse 	% mse bound trace record
  global h_trace_new 	% dummy variable used in appending to trace list

